------------------------------------------------------------------------------------------
--Power Bar Setup-------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, LSM, _ = unpack(select(2,...))
--local m = SNmedia.media
local powertype
local powcolor = {}
local predictBase = 14
local newPredict
local adj = 0
local spec
local GetSpecialization = GetSpecialization
local UnitClass = UnitClass
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local UnitPowerType = UnitPowerType
local GetSpellInfo = GetSpellInfo
local UnitAura = UnitAura

function SN:SetupPower()

	local SNd = SN.data.profile
	F.powermover = CreateFrame("Frame", nil, UIParent)
	F.powermover:SetPoint(unpack(SNd.Frames.power))
	F.powermover:SetSize(269, 24)
	F.powermover.value = F.powermover:CreateFontString(nil, "OVERLAY")
	F.powermover.value:SetPoint("CENTER", F.powermover, "CENTER", 4, 0)
	F.powermover.value:SetFontObject(GameFontNormal)
	F.powermover.value:SetJustifyH("CENTER")
	F.powermover.value:SetShadowOffset(1, -1)
	
	F.powercontainer = CreateFrame("Frame", nil, F.powermover)
	F.powercontainer:SetPoint("CENTER", F.powermover, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		F.powercontainer:SetSize(264, 24)
		SN:SNCreateBG(F.powercontainer)
	else
		F.powermover:SetSize(264, 24)
		F.powercontainer:SetSize(258, 30)
		F.powercontainer:SetBackdrop({
		bgFile = LSM.media.blankTex, 
		edgeFile = LSM.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 4, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		F.powercontainer:SetBackdropColor(0.1, 0.1, 0.1, 0.3)
		F.powercontainer:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	
	F.powercontainer.value = F.powercontainer:CreateFontString(nil, "ARTWORK")
	F.powercontainer.value:SetFont(LSM.media.font, 24, "OUTLINE")
	F.powercontainer.value:SetTextColor(0.78, 0.25, 0.25)
	F.powercontainer.value:SetText("")
	F.powercontainer.value:SetAllPoints(F.powercontainer)
	F.powercontainer.value:SetJustifyH("CENTER")
	F.powercontainer.value:SetJustifyV("MIDDLE")

	F.powercontainer:SetScript("OnMouseDown", function(self, button)
		if self:IsMovable() then
			if button == "LeftButton" and not self.isMoving then
				self:StartMoving()
				self.isMoving = true
			end
		end
	end)
	F.powercontainer:SetScript("OnMouseUp", function(self, button)
		if self:IsMovable() then
			if button == "LeftButton" and self.isMoving then
				self:StopMovingOrSizing()
				self.isMoving = false
			end
		end
	end)

	--The actual power bar
	F.power = CreateFrame("StatusBar", nil, F.powercontainer)
	F.power:SetPoint("CENTER", F.powercontainer, "CENTER", 0, 0)
	F.power:SetSize(264, 23)
	F.power:SetStatusBarTexture(LSM.media.minTex)
	F.power:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
	F.power:SetMinMaxValues(0, (UnitPowerMax("player") > 0) and UnitPowerMax("player") or 100)	
	F.power:SetValue(UnitPower("player"))
	F.power.TimeSinceLastUpdate = 0
	F.power:SetScript("OnUpdate", UpdatePower)
	F.power:SetBackdrop({
				bgFile = LSM.media.blankTex,
			})
	F.power:SetBackdropColor(0.1, 0.1, 0.1, 0)
	F.power.powcolor = {}
	F.power.spec = spec
	SN:GetPowerColor()
	F.power:SetStatusBarColor(F.power.powcolor.r, F.power.powcolor.g, F.power.powcolor.b, 1)
	F.power:SetMinMaxValues(0, (UnitPowerMax("player") > 0) and UnitPowerMax("player") or 100)
	F.power:SetScript("OnEvent", function(self, event, ...)
		if event == "UNIT_SPELLCAST_START" then
			local sourceName, spellName, _, _, spellId = ...
		
			if sourceName == "player" then
				--Check to see if the focus gen spells were cast and run the Predict function					
				if spellId  == 56641 or spellId == 77767 then -- HUNTER: Steady Shot / Cobra Shot
					SN:updatePredict()
				end
			end
		end
		if event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_FAILED" then
			local sourceName, spellName, _, _, spellId = ...
			--The focus regen stopped or failed so shut off the prediction
			if spellId == 56641 or spellId == 77767 then -- HUNTER: Steady Shot / Cobra Shot							
				self.predict:Hide()
			end
		end
		if event == "PLAYER_SPECIALIZATION_CHANGED" then
		--Store the new spec to make sure the powerbar is able to display right
			self.spec = GetSpecialization()
		end
	
	end)
	
	--Color time
	local class, classFileName, classID = UnitClass("player")
	local colortmp = RAID_CLASS_COLORS[classFileName]
	color = { colortmp.r, colortmp.g, colortmp.b }

	--The power text
	F.power.value = F.power:CreateFontString(nil, "OVERLAY")
	F.power.value:SetPoint("CENTER", F.power, "CENTER", 4, 0)
	F.power.value:SetFont(LSM.media.font, 14, "OUTLINE")
	F.power.value:SetJustifyH("CENTER")
	F.power.value:SetShadowOffset(1, -1)
	F.power.value:SetTextColor(unpack(color))
	F.power.value:SetText(UnitPower("player"))
	
	--SN:MakeSmooth(F.power)

	F.power.predict = CreateFrame("StatusBar", nil, F.power)			
	F.power.predict:SetStatusBarTexture(F.power:GetStatusBarTexture():GetTexture()) -- Use the main bar's texture
	F.power.predict:SetMinMaxValues(0, 1)
	F.power.predict:SetValue(1)
	F.power.predict:SetFrameLevel(F.power:GetFrameLevel())
	F.power.predict:SetSize((F.power:GetWidth() / 100) * (predictBase + SN:getPredictAdj()), F.power:GetHeight())

	if (select(2, UnitClass("player")) == "HUNTER") or (select(2, UnitClass("player")) == "DRUID" and GetSpecialization() == 2 or GetSpecialization() == 3)
					or (select(2, UnitClass("player")) == "WARRIOR") or (select(2, UnitClass("player")) == "ROGUE") 
						or (select(2, UnitClass("player")) == "DEATHKNIGHT") then
		for i=1, 2 do
			if (GetClass(i, 1) == true) then
				
				local _, _name, _cost
				if i > 1 then
					name, _, _, cost = GetSpellInfo(GetClass(i, 2))
				end
				
				if (i == 1) or ( (i > 1) and name and cost and (cost > 0) ) then
					F.power["tick"..i] = CreateFrame("Frame", "SN_POWER_TICKS"..i, F.power)
					F.power["tick"..i]:SetSize(10, F.power:GetHeight() * 1.6)
					F.power["tick"..i].tex = F.power["tick"..i]:CreateTexture(nil, "OVERLAY")
					F.power["tick"..i].tex:SetAllPoints(F.power["tick"..i])
					F.power["tick"..i].tex:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")	
					F.power["tick"..i].tex:SetBlendMode("ADD")
				end
				F.power["tick"..i]:Hide()
			end
		end
	end

	SN:PowebarTicks()
	SN:GetPowerColor()
	local POWER_TEST = select(2, UnitPowerType("player"))
	
	if POWER_TEST == "RAGE" or POWER_TEST == "ENERGY" or POWER_TEST == "FOCUS" or POWER_TEST == "RUNIC_POWER" then 
		if not SNd.powerbar.enable then
			SN:PowerDisable()
		end
	else
		SN:PowerDisable()
	end
end

function SN:GetPowerColor()
	
	powertype = select(2, UnitPowerType("player"))
	
	if powertype == "RAGE" then
		powcolor = LSM.power.RAGE
	elseif powertype == "FOCUS" then
		powcolor = LSM.power.FOCUS
	elseif powertype == "ENERGY" then
		powcolor = LSM.power.ENERGY
	elseif powertype == "RUNIC_POWER" then
		powcolor = LSM.power.RUNIC_POWER
	end
	
	F.power.powcolor = powcolor
end

local SN_UpdateInterval = SN_UpdateInterval

function UpdatePower(frame, elapsed)
	
	local SNd = SN.data.profile
	frame.TimeSinceLastUpdate = frame.TimeSinceLastUpdate + elapsed
	if frame.TimeSinceLastUpdate > SN_UpdateInterval then

		frame.TimeSinceLastUpdate = 0
		frame:SetValue(UnitPower("player"))
		frame:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
		frame.value:SetText(UnitPower("player"))
		F.power:SetMinMaxValues(0, (UnitPowerMax("player") > 0) and UnitPowerMax("player") or 100)

		-- Spell tick marks
		if (select(2, UnitClass("player")) == "HUNTER") or (select(2, UnitClass("player")) == "DRUID" and GetSpecialization() == 2 or GetSpecialization() == 3)
					or (select(2, UnitClass("player")) == "WARRIOR") or (select(2, UnitClass("player")) == "ROGUE") 
						or (select(2, UnitClass("player")) == "DEATHKNIGHT") then
				
			if SNd.powerbar.enable then
				local _, name, cost 
				for jj=1, 2 do
					if (GetClass(jj, 1) == true) and (frame["tick"..jj] ~= nil) 
						and (GetClass(1, 1) == true) then
				
						if (jj > 1) then
							name, _, _, cost = GetSpellInfo(GetClass(jj, 2))
						end
						if frame["tick"..jj]:IsShown() then
							if (jj == 1) or ( (jj > 1) and name and cost and (cost > 0) ) then
								if jj == 1 then
									frame["tick"..jj]:ClearAllPoints()
									frame["tick"..jj]:SetPoint("LEFT", frame, "LEFT", SN:GetSpecSpellCost() * (frame:GetWidth() / select(2, frame:GetMinMaxValues() ) ) - 5, 0)
								else
									frame["tick"..jj]:ClearAllPoints()
									frame["tick"..jj]:SetPoint("LEFT", frame, "LEFT", 
										( (GetClass(jj, 3) == true) and (SN:GetSpecSpellCost() + cost) or cost ) * 
										(frame:GetWidth() / select(2, frame:GetMinMaxValues() ) ) - 5, 0)
								end
							end
						end
					end
				end
			end
		end
	end
end

local function Smooth(self, value)
	if (value ~= self:GetValue()) or (value == 0) then
		self.smoothing = value
	else
		self.smoothing = nil
	end
end

function SN:MakeSmooth(powerframe)
	if powerframe.SetValue_ORI then return end
	powerframe.SetValue_ORI = powerframe.SetValue
	powerframe.SetValue = Smooth
	
	powerframe.smoother = CreateFrame("Frame", nil, powerframe)
	local min, max = math.min, math.max
	powerframe.smoother:SetScript("OnUpdate", function(self)
		local rate = GetFramerate()
		local limit = 30 / rate
		if self:GetParent().smoothing then
			local cur = self:GetParent():GetValue()
			local new = cur + min((self:GetParent().smoothing - cur) / 3, max(self:GetParent().smoothing - cur, limit))
			self:GetParent():SetValue_ORI(new)
			if cur == self:GetParent().smoothing or abs(new - self:GetParent().smoothing) < 2 then
				self:GetParent():SetValue_ORI(self:GetParent().smoothing)
				self:GetParent().smoothing = nil
			end
		end
	end)
end

function SN:RemoveSmooth(powerframe)
	if not powerframe.SetValue_ORI then return end
	
	powerframe.smoother:SetScript("OnUpdate", nil)
	powerframe.smoother:SetParent(nil)
	powerframe.smoother = nil
	
	powerframe.SetValue = powerframe.SetValue_ORI
	powerframe.SetValue_ORI = nil
end

function SN:PowebarTicks()
	local name, cost
	local SNd = SN.data.profile
	if (select(2, UnitClass("player")) == "HUNTER") or (select(2, UnitClass("player")) == "DRUID" and GetSpecialization() == 2 or GetSpecialization() == 3)
					or (select(2, UnitClass("player")) == "WARRIOR") or (select(2, UnitClass("player")) == "ROGUE") 
					or (select(2, UnitClass("player")) == "DEATHKNIGHT") then
		
		for i=1, 2 do
			if (GetClass(i, 1) == true) and (GetClass(i, 6) == 0)
						and (GetClass(1, 1) == true) then
				
				if SNd.powerbar.tickenable then	
					local _, _name, _cost
					name, _, _, cost = GetSpellInfo(GetClass(i, 2))
					if (i == 1) or ( (i > 1) and name and cost and (cost > 0) ) then
						F.power["tick"..i]:Show()
					end
				else
					if F.power["tick"..i]:IsShown() then
						F.power["tick"..i]:Hide()	
					end
				end
			end
		end
	end
end

function SN:GetSpecSpellCost()
	currentCost = select(4, GetSpellInfo(GetClass(1, 2)))

	if (currentCost ~= 0) then
		lastCost = currentCost
	end
	return lastCost
end

function SN:getPredictAdj()
	adj = 0
	
	if (GetSpecialization() == 2) and select(1, UnitAura("player", GetSpellInfo(53220), nil, "HELPFUL") ) then -- 53220 = Steady Focus (buff)
		adj = adj + 3
	end
	
	return (adj)
end

function SN:updatePredict()

	-- Add values if AotF active and talent points, and Termination points
	newPredict = predictBase + SN:getPredictAdj()
		
	F.power.predict:SetSize((F.power:GetWidth() / 100) * newPredict, F.power:GetHeight() )

	F.power.predict:ClearAllPoints()
	F.power.predict:SetPoint("LEFT", F.power, "LEFT",	F.power:GetWidth() / (select(2, F.power:GetMinMaxValues() ) / F.power:GetValue() ), 0)

	if (UnitPower("player") + newPredict) > UnitPowerMax("player") then
		F.power.predict:SetSize((F.power:GetWidth() / 100) * (UnitPowerMax("player") - UnitPower("player") ), F.power:GetHeight() )			
	end
		
	F.power.predict:SetStatusBarColor(powcolor.r, powcolor.g, powcolor.b, 1)
		
	if ( (UnitPowerMax("player") - UnitPower("player") ) > 0) and (not UnitIsDeadOrGhost("player") ) then
		F.power.predict:SetAlpha(F.power:GetAlpha() * 0.6)
		F.power.predict:Show()
	else
		F.power.predict:Hide()
	end
end

function GetClass(index, entry)
	local SNd = SN.data.profile
	local class, className = UnitClass("player")
	local spec = GetSpecialization()

	if className == "HUNTER" then
		return SNd.powerbar.hunter[spec][index][entry]
	elseif className == "ROGUE" then
		return SNd.powerbar.rogue[spec][index][entry]
	elseif className == "DRUID" then
		if spec == 2 then
			spec = 1
		elseif spec == 3 then 
			spec = 2
		end
		return SNd.powerbar.druid[spec][index][entry]
	elseif className == "WARRIOR" then
		return SNd.powerbar.warrior[spec][index][entry]
	elseif className == "DEATHKNIGHT" then
		return SNd.powerbar.deathknight[spec][index][entry]
	end
end

function SN:PowerEnable()
	local SNd = SN.data.profile

	if F.powermover ~= nil and not SNd.powerbar.enable then
		F.powermover:Show()
		F.power:RegisterEvent("UNIT_SPELLCAST_START")
		F.power:RegisterEvent("UNIT_SPELLCAST_STOP")
		F.power:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		F.power:RegisterEvent("UNIT_SPELLCAST_FAILED")
		F.power:RegisterEvent("UNIT_MAXPOWER")
		F.power:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
		F.power:RegisterEvent("UNIT_POWER")
		F.power:RegisterEvent("UNIT_DISPLAYPOWER")
	end
end

function SN:PowerDisable()
	local SNd = SN.data.profile

	if F.powermover ~= nil and SNd.powerbar.enable then
		F.power:UnregisterEvent("UNIT_SPELLCAST_START")
		F.power:UnregisterEvent("UNIT_SPELLCAST_STOP")
		F.power:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		F.power:UnregisterEvent("UNIT_SPELLCAST_FAILED")
		F.power:UnregisterEvent("UNIT_MAXPOWER")
		F.power:UnregisterEvent("PLAYER_SPECIALIZATION_CHANGED")
		F.power:UnregisterEvent("UNIT_POWER")
		F.power:UnregisterEvent("UNIT_DISPLAYPOWER")
		F.powermover:Hide()
	end
end