﻿------------------------------------------------------------------------------------------
--Druid Eclipse Bar-----------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, LSM, _ = unpack(select(2,...))


local ECLIPSE_BAR_SOLAR_BUFF_ID = ECLIPSE_BAR_SOLAR_BUFF_ID
local ECLIPSE_BAR_LUNAR_BUFF_ID = ECLIPSE_BAR_LUNAR_BUFF_ID
local SPELL_POWER_ECLIPSE = SPELL_POWER_ECLIPSE
local MOONKIN_FORM = MOONKIN_FORM
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitAura = UnitAura
local GetShapeshiftFormID = GetShapeshiftFormID
local GetSpecialization = GetSpecialization

function SN:SetupEclipse()
	if select(2, UnitClass("player")) ~= "DRUID" and GetSpecialization() ~= 1 then return end
	local SNd = SN.data.profile
	local color = LSM.classResources.DRUID

	local power = UnitPower("player", SPELL_POWER_ECLIPSE)
	local maxPower = UnitPowerMax("player", SPELL_POWER_ECLIPSE)

	local eclipse = CreateFrame("Frame", nil, F.classpower)
	eclipse:SetSize(269, 16)
	eclipse:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(eclipse)
	end
	eclipse:SetScript("OnEvent", function(self, event, ...)
		SN:EclipseUpdate(self, event, ...)
	end)
	
	eclipse.lunar = CreateFrame("StatusBar", nil, eclipse)
	eclipse.solar = CreateFrame("Frame", nil, eclipse)
	
	eclipse.lunar:SetSize(269, 13)
	eclipse.lunar:SetPoint("TOPLEFT", eclipse, "TOPLEFT", 1, -1)
	eclipse.lunar:SetBackdrop({
		bgFile = LSM.media.minTex, 
		edgeFile = LSM.media.blankTex, 
		tile = false, tileSize = 0, edgeSize = 4, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
	eclipse.lunar:SetBackdropColor(unpack(color[1]))
	eclipse.lunar:SetAlpha(1)

	eclipse.solar:SetSize(269, 13)
	eclipse.solar:SetPoint("TOPLEFT", eclipse, "TOPLEFT", 1, -1)
	eclipse.solar:SetStatusBarTexture(LSM.media.minTex)
	eclipse.solar:GetStatusBarTexture():SetHorizTile(false)
	eclipse.solar:SetAlpha(1)
	eclipse.solar:SetMinMaxValues(0, maxpower)
	eclipse.solar:SetValue(power)
	eclipse.solar:SetStatusBarColor(unpack(color[2]))
	
	eclipse:RegisterEvent("ECLIPSE_DIRECTION_CHANGE")
	eclipse:RegisterEvent("PLAYER_TALENT_UPDATE")
	eclipse:RegisterEvent("UNIT_AURA")
	eclipse:RegisterEvent("UNIT_POWER")
	eclipse:RegisterEvent("UPDATE_SHAPESHIFT_FORM")

	if not SNd.classResources.enable or (SN.playerClass == "DRUID" and GetSpecialization() == 1) then
		SN:EclipseDisable(eclipse)
	end
end

function SN:EclipseUpdate(self, event, ...)
	
	if event == "ECLIPSE_DIRECTION_CHANGE" then
		local power = UnitPower('player', SPELL_POWER_ECLIPSE)
		self.solar:SetValue(power)
	end

	if event == "UNIT_AURA" then
		local i = 1
		local hasSolarEclipse, hasLunarEclipse
		repeat
			local _, _, _, _, _, _, _, _, _, _, spellID = UnitAura(unit, i, 'HELPFUL')

			if(spellID == ECLIPSE_BAR_SOLAR_BUFF_ID) then
				hasSolarEclipse = true
			elseif(spellID == ECLIPSE_BAR_LUNAR_BUFF_ID) then
				hasLunarEclipse = true
			end

			i = i + 1
		until not spellID
	end

	if event == "UPDATE_SHAPESHIFT_FORM" or "PLAYER_TALENT_UPDATE" then
		SN:ShowEclipse(self, event, ...)
	end

end

function ShowEclipse(self, event, ...)
	local showBar
	local form = GetShapeshiftFormID()
	if not form then
		local ptt = GetSpecialization()
		if ptt and ptt == 1 then -- player has balance spec
			showBar = true
		end
	elseif form == MOONKIN_FORM then
		showBar = true
	end

	if showBar then
		SN:EclipseEnable(self)
	else
		SN:EclipseDisable(self)
	end
end

function SN:EclipseEnable(self)
	self:Show()
	self:RegisterEvent("ECLIPSE_DIRECTION_CHANGE")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
end

function SN:EclipseDisable(self)
	
	self:UnregisterEvent("ECLIPSE_DIRECTION_CHANGE")
	self:UnregisterEvent("PLAYER_TALENT_UPDATE")
	self:UnregisterEvent("UNIT_AURA")
	self:UnregisterEvent("UNIT_POWER")
	self:UnregisterEvent("UPDATE_SHAPESHIFT_FORM")
	self:Hide()
	collectgarbage("collect")
end